#include <AFMotor.h>                        //   
#include <avr/wdt.h>                        // 
#include <EEPROM.h>                         //  

                                            //  / 
#define m1o 4000
#define m1c 0
#define m2o 0
#define m2c 4000
#define m3o 10000
#define m3c 10000
#define m4o 16000
#define m4c 17000

#define TimeBlockReciveCommand 40000         //    (      )

#define ErorTime 10000                       //   
#define TimeLoopCover 500                    //    

#define Open 2                               // Open Cover
#define Close 13                             // Close Cover
#define M1Open A0                            // Motor1 Open
#define M1Close A1                           // Motor1 Close
#define M2Open A2                            // Motor2 Open
#define M2Close A3                           // Motor2 Close
#define M3Open A4                            // Motor3 Open
#define M3Close A5                           // Motor3 Close
#define M4Open 10                            // Motor4 Open
#define M4Close 9                            // Motor4 Close

byte StartOpen = 0;                 //    
byte StartClose = 0;                //    
byte BlockReciveCommand = 0;        //   

byte OpenCounter = 0;               //  
byte OpenCover1 = 0;                //  
byte OpenCover2 = 0;                //  
byte OpenCover3 = 0;                //  
byte OpenCover4 = 0;                //  

byte CloseCounter = 0;               //  
byte CloseCover1 = 0;                //  
byte CloseCover2 = 0;                //  
byte CloseCover3 = 0;                //  
byte CloseCover4 = 0;                //  

AF_DCMotor motor1(1);                       //   motor #1, 1  
AF_DCMotor motor2(2);                       //   motor #2, 1  
AF_DCMotor motor3(3);                       //   motor #3, 1  
AF_DCMotor motor4(4);                       //   motor #4, 1  

unsigned long ms;                           //     
byte Button_Block = 0;                      //  

void setup()
{
    wdt_enable(WDTO_500MS);          //  500m
    pinMode(Open, INPUT_PULLUP);     // Open Cover
    pinMode(Close, INPUT_PULLUP);    // Close Cover
                                                //  DC motor +   +5V
    pinMode(M1Open, INPUT_PULLUP);   //Motor1 Open
    pinMode(M1Close, INPUT_PULLUP);  //Motor1 Close
    pinMode(M2Open, INPUT_PULLUP);   //Motor2 Open
    pinMode(M2Close, INPUT_PULLUP);  //Motor2 Close
    pinMode(M3Open, INPUT_PULLUP);   //Motor3 Open
    pinMode(M3Close, INPUT_PULLUP);  //Motor3 Close
    pinMode(M4Open, INPUT_PULLUP);   //Motor4 Open
    pinMode(M4Close, INPUT_PULLUP);  //Motor4 Close

    motor1.setSpeed(255);               //    255  255 
    motor2.setSpeed(255);               //    255  255 
    motor3.setSpeed(255);               //    255  255 
    motor4.setSpeed(255);               //    255  255 

    Serial.begin(9600); //     9600 bps
    Serial.println("Motor test OK!");

    StartOpen = EEPROM.read(1);
    StartClose = EEPROM.read(2);

    ms = millis();
}

void loop()
{
    if (digitalRead(Open) == LOW && Button_Block == 0 && BlockReciveCommand == 0)  //   OPEN
    {
        ms = millis();           //   
        Button_Block = 1;        //  
        BlockReciveCommand = 1;  //  
        StartOpen = 1;           //   
        StartClose = 0;          // 
        Serial.println("Open process...");
    }

    if (digitalRead(Close) == LOW && Button_Block == 0 && BlockReciveCommand == 0)  //   CLOSE
    {
        ms = millis();           //   
        Button_Block = 1;        //  
        BlockReciveCommand = 1;  //  
        StartClose = 1;          //   
        StartOpen = 0;           // 
        Serial.println("Close process...");
    }

    if (millis() - ms > TimeLoopCover) { Button_Block = 0; }                 //   
    if (millis() - ms > TimeBlockReciveCommand) { BlockReciveCommand = 0; }  //    


    if (StartOpen == 1)                                   //   
    {
        EEPROM.write(1, StartOpen);
        if ((millis() - ms > m1o) && (OpenCover1 == 0))                              //  1  
        {
            if (digitalRead(M1Open) == 1)
            {
                motor1.run(FORWARD);
            }
            else
            {
                motor1.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover1 = 1;
                Serial.println("Motor 1 Stop Open");
            }
            if ((millis() - ms > m1o + ErorTime) && (digitalRead(M1Open) == 1))    //    1 
            {
                motor1.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover1 = 1;
                Serial.println("Motor 1 Eror Stop Open");
            }
        }

        if ((millis() - ms > m2o) && (OpenCover2 == 0))                              //  2  
        {
            if (digitalRead(M2Open) == 1)
            {
                motor2.run(FORWARD);
            }
            else
            {
                motor2.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover2 = 1;
                Serial.println("Motor 2 Stop Open");
            }
            if ((millis() - ms > m2o + ErorTime) && (digitalRead(M2Open) == 1))    //    2 
            {
                motor2.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover2 = 1;
                Serial.println("Motor 2 Eror Stop Open");
            }
        }

        if ((millis() - ms > m3o) && (OpenCover3 == 0))                              //  3  
        {
            if (digitalRead(M3Open) == 1)
            {
                motor3.run(FORWARD);
            }
            else
            {
                motor3.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover3 = 1;
                Serial.println("Motor 3 Stop Open");
            }
            if ((millis() - ms > m3o + ErorTime) && (digitalRead(M3Open) == 1))    //    3 
            {
                motor3.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover3 = 1;
                Serial.println("Motor 3 Eror Stop Open");
            }
        }

        if ((millis() - ms > m4o) && (OpenCover4 == 0))                              //  3  
        {
            if (digitalRead(M4Open) == 1)
            {
                motor4.run(FORWARD);
            }
            else
            {
                motor4.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover4 = 1;
                Serial.println("Motor 4 Stop Open");
            }
            if ((millis() - ms > m4o + ErorTime) && (digitalRead(M4Open) == 1))    //    4 
            {
                motor4.run(RELEASE);
                OpenCounter = OpenCounter + 1;
                OpenCover4 = 1;
                Serial.println("Motor 4 Eror Stop Open");
            }
        }

        if (OpenCounter > 3)                        //   (  )
        {
            StartOpen = 0;                          //   
            EEPROM.write(1, StartOpen);
            OpenCounter = 0;
            OpenCover1 = 0;
            OpenCover2 = 0;
            OpenCover3 = 0;
            OpenCover4 = 0;
        }
    }


    if (StartClose == 1)                              //   
    {
        EEPROM.write(2, StartClose);
        if ((millis() - ms > m1c) && (CloseCover1 == 0))                              //  1  
        {
            if (digitalRead(M1Close) == 1)
            {
                motor1.run(BACKWARD);
            }
            else
            {
                motor1.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover1 = 1;
                Serial.println("Motor 1 Stop Close");
            }
            if ((millis() - ms > m1c + ErorTime) && (digitalRead(M1Close) == 1))    //    1 
            {
                motor1.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover1 = 1;
                Serial.println("Motor 1 Eror Stop Close");
            }
        }

        if ((millis() - ms > m2c) && (CloseCover2 == 0))                              //  2  
        {
            if (digitalRead(M2Close) == 1)
            {
                motor2.run(BACKWARD);
            }
            else
            {
                motor2.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover2 = 1;
                Serial.println("Motor 2 Stop Close");
            }
            if ((millis() - ms > m2c + ErorTime) && (digitalRead(M2Close) == 1))    //    2 
            {
                motor2.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover2 = 1;
                Serial.println("Motor 2 Eror Stop Close");
            }
        }

        if ((millis() - ms > m3c) && (CloseCover3 == 0))                              //  3  
        {
            if (digitalRead(M3Close) == 1)
            {
                motor3.run(BACKWARD);
            }
            else
            {
                motor3.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover3 = 1;
                Serial.println("Motor 3 Stop Close");
            }
            if ((millis() - ms > m3c + ErorTime) && (digitalRead(M3Close) == 1))    //    3 
            {
                motor3.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover3 = 1;
                Serial.println("Motor 3 Eror Stop Close");
            }
        }

        if ((millis() - ms > m4c) && (CloseCover4 == 0))                              //  3  
        {
            if (digitalRead(M4Close) == 1)
            {
                motor4.run(BACKWARD);
            }
            else
            {
                motor4.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover4 = 1;
                Serial.println("Motor 4 Stop Close");
            }
            if ((millis() - ms > m4c + ErorTime) && (digitalRead(M4Close) == 1))    //    4 
            {
                motor4.run(RELEASE);
                CloseCounter = CloseCounter + 1;
                CloseCover4 = 1;
                Serial.println("Motor 4 Eror Stop Close");
            }
        }

        if (CloseCounter > 3)                        //   (  )
        {
            StartClose = 0;                          //   
            EEPROM.write(2, StartClose);
            CloseCounter = 0;
            CloseCover1 = 0;
            CloseCover2 = 0;
            CloseCover3 = 0;
            CloseCover4 = 0;
        }
    }

    while (Serial.available())
    {
        String buf = Serial.readStringUntil('\r');    //    '\r'
        if (buf.charAt(0) == 'C')
        {
            switch (buf.charAt(1))
            {
                case 'O': {
                        ms = millis();           //   
                        Button_Block = 1;        //  
                        BlockReciveCommand = 1;  //  
                        StartOpen = 1;           //   
                        StartClose = 0;          // 
                    } break;
                case 'C': {
                        ms = millis();           //   
                        Button_Block = 1;        //  
                        BlockReciveCommand = 1;  //  
                        StartOpen = 0;           // 
                        StartClose = 1;          //   

                    } break;
                case 'S': {
                        if (digitalRead(M1Open) == 0 || digitalRead(M2Open) == 0 || digitalRead(M3Open) == 0 || digitalRead(M4Open) == 0)
                        {
                            Serial.print('C'); Serial.println('O');  // 
                        }
                        else if (digitalRead(M1Close) == 0 || digitalRead(M2Close) == 0 || digitalRead(M3Close) == 0 || digitalRead(M4Close) == 0)
                        {
                            Serial.print('C'); Serial.println('C');  // 
                        }
                        else
                        {
                            Serial.print('C'); Serial.println('N');  // 
                        }

                    } break;
            }
        }
    }
    wdt_reset(); //  
}
